package HFE;

import java.lang.*;
import java.io.*;
import java.util.*;
import java.security.*;
import sun.misc.*;
import HFE.*;

//-----------------------------------------------------------------------------
// Project:     Implementing QuartzLight in Java
//-----------------------------------------------------------------------------

/**
<p>
Interface for {@link RootFinding}. Checks if a root found is really
the root we wanted. If so, class {@link RootFinding} can stop
to search for this root.
<p>
@author Christopher Wolf (hfe@Christopher-Wolf.de)
@version 0.1
*/

//Copyright (C) 2002    Christopher Wolf
//
//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License (file LICENCE) for more details.


interface CheckRoot {

   /**
     Checks if the root is the one which is wanted by HFE. In a signature scheme,
     this method always signals <code>true</code>. In a decryption scheme, however,
     it depends on additional information, e.g. a hash value of root.
     @return true iff the root is the correct one
   */
   public boolean checkRoot(Field2_n root);
}
